package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.dao.EndOfSaleRepo;
import com.nisum.offertransactionservice.model.EndOfSaleReq;
import com.nisum.offertransactionservice.model.EndOfSaleEntity;
import lombok.extern.slf4j.Slf4j;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.UUID;

@Service
@Slf4j
public class EndOfSaleService {

    @Autowired
    private EndOfSaleRepo endOfSaleRepo;



    public UUID putEndofSaleResInDb(EndOfSaleReq endOfSaleReq) throws IOException {
        ObjectMapper mapper = new ObjectMapper();
        String offerTransactionResponseJson = mapper.writeValueAsString(endOfSaleReq.getOfferTransactionResponse());
        String offersJosn = mapper.writeValueAsString(endOfSaleReq.getOffers());
        EndOfSaleEntity endOfSaleEntity = new EndOfSaleEntity();
        endOfSaleEntity.setOfferTransactionResponse(offerTransactionResponseJson);
        endOfSaleEntity.setOffers(offersJosn);
        endOfSaleEntity.setUuid(UUID.randomUUID());
        endOfSaleRepo.save(endOfSaleEntity);
        return endOfSaleEntity.getUuid();
    }

}
